<template>
  <Modal
    :options="getModalOptions"
    :on-positive-click="handleConfirm"
    :on-negative-click="handleClose"
    :on-close="handleClose"
  >
    <template #Context>
      <n-form
        ref="formRef"
        :model="roleForm"
        :rules="roleRules"
        :label-width="80"
        label-placement="left"
        require-mark-placement="left"
        :disabled="disabled"
      >
        <template v-for="(item,index) in getFormOptions" :key="index">
          <n-form-item :label="item.label" :path="item.key">
            <n-input v-if="item.type === 'input'" v-model:value="roleForm[item.key]" v-bind="item.props" />
            <n-radio-group v-if="item.type === 'radio'" v-model:value="roleForm[item.key]" :name="item.key">
              <n-space>
                <n-radio v-for="(cItem,cIndex) in item.options" :key="`${item.key}_${cIndex}`" :value="cItem.value"> {{ cItem.label }}</n-radio>
              </n-space>
            </n-radio-group>
          </n-form-item>
        </template>
      </n-form>
    </template>
  </Modal>
</template>

<script>
import form from '../tools/form.js'
import { defineComponent, ref, reactive, computed, toRefs } from 'vue'
import Modal from '@/components/Modal/index.vue'
import { addRole, editRole } from '@/api/system/role/index'
export default defineComponent({
  name: 'RoleModal',
  components: { Modal },
  props: {
    visible: {
      type: Boolean,
      default: false
    },
    type: {
      type: String,
      default: 'create'
    },
    data: {
      type: Object,
      default: () => {}
    }
  },
  emits: {
    'update:visible': null,
    'reload': null
  },
  setup(props, { emit }) {
    const MODAL_TYPE = {
      'create': '新建角色',
      'preview': '角色详情',
      'update': '编辑角色'
    }
    const { roleForm, roleRules } = form
    const formRef = ref()
    const data = reactive({
      roleForm: {
        ...roleForm,
        ...props.data
      },
      roleRules: {
        ...roleRules
      },
      disabled: props.type === 'preview'
    })

    const getModalOptions = computed(() => {
      return {
        title: MODAL_TYPE[props.type],
        show: props.visible,
        negativeText: '取消',
        positiveText: '确认'
      }
    })

    const getFormOptions = computed(() => {
      return {
        ...form.formItem
      }
    })

    function handleConfirm() {
      formRef.value?.validate((errors) => {
        if (!errors) {
          const params = { ...data.roleForm }
          if (params.id) {
            /* 编辑 */
            editRole(params)
              .then(res => {
                if (res.code === 0) {
                  emit('reload')
                  handleClose()
                }
              })
          } else {
            /* 新增 */
            addRole(params)
              .then(res => {
                if (res.code === 0) {
                  emit('reload')
                  handleClose()
                }
              })
          }
        } else {
          $message.error('请完善必填信息')
        }
      })
    }

    /* 关闭弹窗 */
    const handleClose = () => {
      emit('update:visible', false)
    }

    return {
      ...toRefs(data),
      formRef,
      getModalOptions,
      getFormOptions,
      handleConfirm,
      handleClose
    }
  }
})
</script>
<style scoped lang='scss'>
</style>
